#include "../Compression.h"

#ifdef __cplusplus

//      COMPRESSION_METHOD
class LZMA_METHOD : public COMPRESSION_METHOD
{
public:
  //    
  MemSize dictionarySize;
  MemSize hashSize;
  int     algorithm;
  int     numFastBytes;
  int     matchFinder;
  int     matchFinderCycles;
  int     posStateBits;
  int     litContextBits;
  int     litPosBits;

  // ,       
  LZMA_METHOD();

  //  ,    "has_progress?"
  virtual int doit (char *what, int param, void *data, CALLBACK_FUNC *callback);
  // /  
  virtual int DeCompressMem (COMPRESSION direction, void *input, int inputSize, void *output, int *outputSize, CALLBACK_FUNC *callback=0, void *auxdata=0, void **CodecState=0);
  //    
  virtual int decompress (CALLBACK_FUNC *callback, void *auxdata);
#ifndef FREEARC_DECOMPRESS_ONLY
  virtual int compress   (CALLBACK_FUNC *callback, void *auxdata);

  //       -  
  void CalcCompressionMemories (MemSize *pmem, MemSize *phashSize);

  // /  ,   /,     
  virtual MemSize GetCompressionMem        (void);
  virtual void    SetCompressionMem        (MemSize mem);
  virtual void    SetMinDecompressionMem   (MemSize mem);
  virtual void    SetDictionary            (MemSize dict);
#endif
  virtual MemSize GetDictionary            (void)               {return dictionarySize;}
  virtual MemSize GetDecompressionMem      (void);
  virtual LongMemSize GetMaxCompressedSize (LongMemSize insize) {return insize + (insize/40) + 512;}

  //   buf[MAX_METHOD_STRLEN] ,       (,   parse_LZMA)
  virtual void ShowCompressionMethod (char *buf, bool purify);
};

//     LZMA
COMPRESSION_METHOD* parse_LZMA (char** parameters);

#endif  // __cplusplus
